local pcall = pcall

local oop = require "loop.base"

---
-- Classe que representa um teste
--
module("latt.Test", oop.class)

---
-- O construtor do teste
--
-- @param self
-- @param name
-- @param test
-- @param testCase
--
function __new(self, name, test, testCase)
  return oop.rawnew(self, { name = name, test = test, testCase = testCase, })
end

---
-- Executa o teste
--
-- @param self
-- @param result
--
function run(self, result)
  result:startTest(self.name)
  local _, errorMessage = pcall(self.test, self.testCase)
  result:stopTest(errorMessage)
end
